// SPDX-License-Identifier: GPL-2.0

#include <linux/kernel.h>
#include <linux/module.h>

static int __init my_init(void)
{
	/*
	 * c'est une macro récente qui permet de remplacer prink(KERN_INFO "coucou")
	 */
	pr_info("Coucou le gens !!!!\n");
	return 0;
}

static void __exit my_exit(void)
{
	pr_info("Tschuss !!!\n");
}

/*
 * avant, on utilisait les fonctions int init_module(void) et
 * void cleanup_module(void) à la place des macros pour initialiser le module.
 *
 * la méthode la plus récente pour faire des modules est d'utiliser les macros
 * suivantes pour définir les fonctions d'initialisation et de sortie.
 */
module_init(my_init);
module_exit(my_exit);

MODULE_LICENSE("GPL");
MODULE_AUTHOR("rick <rick@gnous.eu>");
MODULE_DESCRIPTION("Module de la premiere tache de l'Eudyptula challenge");
